package org.jeecg.modules.seal.utils.DigitalCertificate;

import com.alibaba.fastjson.JSON;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Image;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.AcroFields;
import com.itextpdf.text.pdf.PdfDictionary;
import com.itextpdf.text.pdf.PdfIndirectReference;
import com.itextpdf.text.pdf.PdfName;
import com.itextpdf.text.pdf.PdfObject;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfSignatureAppearance;
import com.itextpdf.text.pdf.PdfStamper;
import com.itextpdf.text.pdf.PdfStream;
import com.itextpdf.text.pdf.AcroFields.FieldPosition;
import com.itextpdf.text.pdf.AcroFields.Item;
import com.itextpdf.text.pdf.PdfSignatureAppearance.RenderingMode;
import com.itextpdf.text.pdf.parser.ContentByteUtils;
import com.itextpdf.text.pdf.parser.PdfContentStreamProcessor;
import com.itextpdf.text.pdf.security.BouncyCastleDigest;
import com.itextpdf.text.pdf.security.CertificateInfo;
import com.itextpdf.text.pdf.security.MakeSignature;
import com.itextpdf.text.pdf.security.OcspClient;
import com.itextpdf.text.pdf.security.PdfPKCS7;
import com.itextpdf.text.pdf.security.PrivateKeySignature;
import com.itextpdf.text.pdf.security.TSAClient;
import com.itextpdf.text.pdf.security.MakeSignature.CryptoStandard;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.lang.reflect.Field;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.security.GeneralSecurityException;
import java.security.KeyStore;
import java.security.Principal;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Security;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.Base64;
import java.util.Collection;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import java.util.Set;
import java.util.Base64.Encoder;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import org.jeecg.modules.seal.config.ResponseResult;
import org.jeecg.modules.seal.entity.PdfSignInfo;
import org.jeecg.modules.seal.entity.SealSigner;
import org.jeecg.modules.seal.entity.PdfSignInfo.SignatureDetail;
import org.jeecg.modules.seal.utils.FileOSS;
import org.jeecg.modules.seal.utils.FileUtils;
import org.jeecg.modules.seal.utils.DigitalCertificate.ExtImageRenderListener;
import org.jeecg.modules.seal.utils.DigitalCertificate.ImageUtils;

public class KeyStoreGenerate {

   private static String KEYSTORE_PATH = "./data/demo.ks";
   private static String KEYSTORE_PASSWORD = "111111";
   private static String KEYSTORE_TYPE = "PKCS12";
   private static String PDF_PATH = "./data/test2.pdf";
   private static String PDF_SIGNED = "./data/success.pdf";
   private static String SIGN_IMG = "./data/test1.png";
   private static String CHK_PDF = "./data/chk.pdf";


   public static void main(String[] args) throws Exception {
      getSignFromPdf("/Users/zymac/Desktop/SealBack/data/su.pdf");
   }

   public static ResponseResult signPdf(String pdfPath, String sealPath, SealSigner sealSigner) throws Exception {
      BouncyCastleProvider provider = new BouncyCastleProvider();
      Security.addProvider(provider);
      String pfxFilePath = "./data/" + sealSigner.getSignerId() + ".pfx";
      FileInputStream inputStream = new FileInputStream(pfxFilePath);
      KeyStore keyStore = KeyStore.getInstance("PKCS12");
      keyStore.load(inputStream, KEYSTORE_PASSWORD.toCharArray());
      String alias = (String)keyStore.aliases().nextElement();
      PrivateKey privateKey = GetPvkformPfx(pfxFilePath, "111111");
      Certificate[] chain = keyStore.getCertificateChain(alias);
      String digestAlgorithm = "SHA-256";
      CryptoStandard subfilter = CryptoStandard.CMS;
      PdfReader reader = new PdfReader(pdfPath);
      Rectangle pageSize = reader.getPageSize(1);
      FileOutputStream os = new FileOutputStream(new File(PDF_SIGNED));
      PdfStamper stamper = PdfStamper.createSignature(reader, os, '\u0000', new File("/tmp/pdf"), true);
      PdfSignatureAppearance appearance = stamper.getSignatureAppearance();
      appearance.setReason("小周毕业设计专用");
      appearance.setLocation("小周毕业设计专用");
      int signPage = sealSigner.getSignerSignPage().intValue();
      int llx = (int)(sealSigner.getSignerSignX().doubleValue() - 40.0D);
      int lly = (int)(842.0D - sealSigner.getSignerSignY().doubleValue() + 40.0D);
      int urx = llx + 150;
      int ury = lly + 150;
      appearance.setVisibleSignature(new Rectangle((float)llx, (float)lly, (float)urx, (float)ury), signPage, System.currentTimeMillis() + "");
      Image image = Image.getInstance(sealPath);
      appearance.setSignatureGraphic(image);
      appearance.setCertificationLevel(0);
      appearance.setRenderingMode(RenderingMode.GRAPHIC);
      PrivateKeySignature pks = new PrivateKeySignature(privateKey, digestAlgorithm, provider.getName());
      BouncyCastleDigest digest = new BouncyCastleDigest();
      MakeSignature.signDetached(appearance, digest, pks, chain, (Collection)null, (OcspClient)null, (TSAClient)null, 0, subfilter);
      FileInputStream inputStream1 = new FileInputStream(PDF_SIGNED);
      return FileOSS.streamPdfUploadOSS(inputStream1);
   }

   public static PrivateKey GetPvkformPfx(String strPfx, String strPassword) {
      try {
         BouncyCastleProvider e = new BouncyCastleProvider();
         Security.addProvider(e);
         KeyStore ks = KeyStore.getInstance("PKCS12");
         FileInputStream fis = new FileInputStream(strPfx);
         Object nPassword = null;
         char[] nPassword1;
         if(strPassword != null && !strPassword.trim().equals("")) {
            nPassword1 = strPassword.toCharArray();
         } else {
            nPassword1 = null;
         }

         ks.load(fis, nPassword1);
         fis.close();
         System.out.println("keystore type=" + ks.getType());
         Enumeration enumas = ks.aliases();
         String keyAlias = null;
         if(enumas.hasMoreElements()) {
            keyAlias = (String)enumas.nextElement();
            System.out.println("alias=[" + keyAlias + "]");
         }

         System.out.println("is key entry=" + ks.isKeyEntry(keyAlias));
         PrivateKey prikey = (PrivateKey)ks.getKey(keyAlias, nPassword1);
         Certificate[] cert = ks.getCertificateChain(keyAlias);
         System.out.println("chain size " + cert.length);
         PublicKey pubkey = cert[0].getPublicKey();
         System.out.println("cert class = " + cert.getClass().getName());
         System.out.println("cert = " + cert);
         System.out.println("public key = " + pubkey);
         System.out.println("private key = " + prikey);
         return prikey;
      } catch (Exception var11) {
         var11.printStackTrace();
         return null;
      }
   }

   public static PdfSignInfo getSignFromPdf(String path) {
      path = System.getProperty("user.dir") + "/src/main/resources/static" + path;
      PdfSignInfo pdfSignInfo = new PdfSignInfo();
      String fileBasePath = System.getProperty("user.dir") + "/src/main/resources/static/upload/";

      try {
         File e = new File(path);
         FileInputStream fis = new FileInputStream(path);
         PdfReader reader = new PdfReader(fis);
         String fileName = path.substring(path.lastIndexOf("/") + 1, path.lastIndexOf("."));
         if(!fileBasePath.endsWith("/")) {
            fileBasePath = fileBasePath + "/";
         }

         pdfSignInfo.setPdfName(path.substring(path.lastIndexOf("/") + 1));
         pdfSignInfo.setPdfSize(String.valueOf(e.length()));
         Field rsaDataField = PdfPKCS7.class.getDeclaredField("RSAdata");
         rsaDataField.setAccessible(true);
         int numberOfPages = reader.getNumberOfPages();
         System.out.println("page size: " + numberOfPages);
         int xrefSize = reader.getXrefSize();
         ExtImageRenderListener listener = new ExtImageRenderListener();
         listener.setBasePath(fileBasePath);
         AcroFields fields = reader.getAcroFields();
         Rectangle pageSize = reader.getPageSize(numberOfPages);
         System.out.println("pdf rectangle: " + pageSize.getLeft() + "," + pageSize.getBottom() + "," + pageSize.getRight() + "," + pageSize.getTop());
         ArrayList signatureNames = fields.getSignatureNames();
         Iterator var14 = signatureNames.iterator();

         while(var14.hasNext()) {
            String name = (String)var14.next();
            PdfPKCS7 pkcs7 = fields.verifySignature(name);
            X509Certificate certificate = pkcs7.getSigningCertificate();
            SignatureDetail info = new SignatureDetail();
            fields.getAppearanceStates(name);
            List fieldPositions = fields.getFieldPositions(name);

            Rectangle encoder;
            for(Iterator fieldItem = fieldPositions.iterator(); fieldItem.hasNext(); info.ury = encoder.getTop()) {
               FieldPosition size = (FieldPosition)fieldItem.next();
               encoder = size.position;
               System.out.println("field " + name + " position: " + size.page + ", " + encoder.getLeft() + ", " + encoder.getBottom() + ", " + encoder.getRight() + ", " + encoder.getTop());
               info.pageNum = size.page;
               info.llx = encoder.getLeft();
               info.lly = encoder.getBottom();
               info.urx = encoder.getRight();
            }

            Item var37 = fields.getFieldItem(name);
            int var38 = var37.size();

            for(int var39 = 0; var39 < var38; ++var39) {
               PdfDictionary digestAttrField = var37.getValue(var39);
               Set digestAttr = digestAttrField.getKeys();
               Iterator pdfObject = digestAttr.iterator();

               while(pdfObject.hasNext()) {
                  PdfName dictionary = (PdfName)pdfObject.next();
                  String ref = PdfName.decodeName(new String(dictionary.getBytes()));
                  if("Rect".equalsIgnoreCase(ref)) {
                     System.out.println("签名域的坐标为：" + digestAttrField.get(dictionary));
                  }
               }

               PdfObject var43 = digestAttrField.get(PdfName.AP);
               if(var43 != null) {
                  PdfDictionary var44 = (PdfDictionary)var43;
                  PdfIndirectReference var45 = (PdfIndirectReference)var44.get(PdfName.N);
                  int number = var45.getNumber();
                  System.out.println("fieldName: " + name + ", idx: " + number);
                  PdfObject pdfObjectRelease = reader.getPdfObject(number);
                  if(pdfObjectRelease instanceof PdfStream) {
                     PdfStream s = (PdfStream)pdfObjectRelease;
                     PdfDictionary resources = s.getAsDict(PdfName.RESOURCES);
                     listener.setI(number);

                     try {
                        PdfContentStreamProcessor processor = new PdfContentStreamProcessor(listener);
                        processor.processContent(ContentByteUtils.getContentBytesFromContentObject(s), resources);
                        changeImgColor(fileBasePath + number + ".png");
                        ResponseResult responseResult = FileOSS.fileUploadOSS(number + ".png");
                        info.filePath = responseResult.getResult().toString();
                        FileUtils.deleteFile(fileBasePath + number + ".png");
                     } catch (Exception var35) {
                        ;
                     }
                  }
               }
            }

            info.signName = name;
            info.signTime = pkcs7.getSignDate().getTime();
            info.validStartTime = certificate.getNotBefore();
            info.validEndTime = certificate.getNotAfter();
            info.certName = certificate.getSubjectDN().getName();
            info.serialNumber = String.valueOf(certificate.getSerialNumber());
            Encoder var40 = Base64.getEncoder();
            info.publicKey = var40.encodeToString(certificate.getPublicKey().getEncoded());
            info.pubKeyFormat = certificate.getPublicKey().getFormat();
            info.sigAlgName = certificate.getSigAlgName();
            info.userDnName = certificate.getIssuerDN().getName();
            info.reason = pkcs7.getReason();
            info.location = pkcs7.getLocation();
            info.validate = pkcs7.verify();
            Field var41 = PdfPKCS7.class.getDeclaredField("digestAttr");
            var41.setAccessible(true);
            byte[] var42 = (byte[])((byte[])var41.get(pkcs7));
            info.fileDigest = var40.encodeToString(var42);
            pdfSignInfo.getSignatureDetails().add(info);
         }

         System.out.println(JSON.toJSONString(pdfSignInfo));
      } catch (Exception var36) {
         var36.printStackTrace();
      }

      FileUtils.deleteFile(path);
      return pdfSignInfo;
   }

   public static void changeImgColor(String path) throws IOException {
      File file = new File(path);
      String fileName = file.getName();
      BufferedImage bi = ImageIO.read(file);
      ImageIcon imageIcon = new ImageIcon(bi);
      int width = imageIcon.getIconWidth();
      int height = imageIcon.getIconHeight();
      BufferedImage bufferedImage = new BufferedImage(width, height, 6);
      Graphics2D graphics2D = (Graphics2D)bufferedImage.getGraphics();
      graphics2D.drawImage(imageIcon.getImage(), 0, 0, imageIcon.getImageObserver());
      boolean alpha = true;
      int RGB = bufferedImage.getRGB(width - 1, height - 1);

      for(int split = bufferedImage.getMinX(); split < width; ++split) {
         for(int j = bufferedImage.getMinY(); j < height; ++j) {
            int rgb = bufferedImage.getRGB(split, j);
            int r = (rgb & 16711680) >> 16;
            int g = (rgb & '\uff00') >> 8;
            int b = rgb & 255;
            int R = (RGB & 16711680) >> 16;
            int G = (RGB & '\uff00') >> 8;
            int B = RGB & 255;
            byte a = 45;
            short var22;
            if(Math.abs(R - r) < a && Math.abs(G - g) < a && Math.abs(B - b) < a) {
               var22 = 0;
            } else {
               var22 = 255;
            }

            rgb = var22 << 24 | rgb & 16777215;
            bufferedImage.setRGB(split, j, rgb);
         }
      }

      String[] var23 = fileName.split("\\.");
      (new StringBuilder()).append(var23[0]).append("(已转换).").append(var23[1]).toString();
      ImageIO.write(bufferedImage, "png", new File(path));
   }

   public static void yanqian() throws IOException, GeneralSecurityException {
      PdfReader pdfReader = new PdfReader("./data/success.pdf");
      AcroFields acroFields = pdfReader.getAcroFields();
      ArrayList names = acroFields.getSignatureNames();
      Iterator var3 = names.iterator();

      while(var3.hasNext()) {
         String name = (String)var3.next();
         PdfDictionary signatureDict = acroFields.getSignatureDictionary(name);
         String timestrap = signatureDict.getAsString(PdfName.M).toString().replace("D:", "").substring(0, 12);
         PdfPKCS7 pdfPKCS7 = acroFields.verifySignature(name);
         X509Certificate x509Certificate = pdfPKCS7.getSigningCertificate();
         Principal principal = x509Certificate.getIssuerDN();
         String s = principal.toString().split("CN")[2].replace("=", "");
         boolean flag = pdfPKCS7.verifyTimestampImprint();
         String signerName = CertificateInfo.getSubjectFields(pdfPKCS7.getSigningCertificate()).getField("CN");
         boolean isChange = pdfPKCS7.verify();
         System.out.println(signerName + "\t时间戳是否有效:" + flag + "\t" + timestrap + "\t颁发机构:" + s + "\t是否被篡改:" + isChange);
      }

   }

   public static void qfz(String alias) throws IOException, DocumentException, GeneralSecurityException {
      PdfReader reader = new PdfReader(PDF_PATH);
      Rectangle pageSize = reader.getPageSize(1);
      float height = pageSize.getHeight();
      float width = pageSize.getWidth();
      int nums = reader.getNumberOfPages();
      Image[] images = ImageUtils.subImages(SIGN_IMG, nums);
      FileInputStream inputStream = new FileInputStream(KEYSTORE_PATH);
      KeyStore keyStore = KeyStore.getInstance(KEYSTORE_TYPE);
      keyStore.load(inputStream, KEYSTORE_PASSWORD.toCharArray());
      PrivateKey privateKey = (PrivateKey)keyStore.getKey(alias, KEYSTORE_PASSWORD.toCharArray());
      Certificate[] chain = keyStore.getCertificateChain(alias);
      String digestAlgorithm = "SHA-256";
      CryptoStandard subfilter = CryptoStandard.CMS;
      PrivateKeySignature pks = new PrivateKeySignature(privateKey, digestAlgorithm, "BC");
      BouncyCastleDigest digest = new BouncyCastleDigest();
      String path = PDF_PATH;
      int i = 1;
      Image[] var17 = images;
      int var18 = images.length;

      for(int var19 = 0; var19 < var18; ++var19) {
         Image image = var17[var19];
         reader = new PdfReader(path);
         path = "./data/" + (new Random()).nextInt(1000) + ".pdf";
         FileOutputStream os = new FileOutputStream(new File(path));
         PdfStamper stamper = PdfStamper.createSignature(reader, os, '\u0000', new File(PDF_SIGNED), true);
         PdfSignatureAppearance appearance = stamper.getSignatureAppearance();
         appearance.setReason("签署理由");
         appearance.setLocation("签署位置");
         appearance.setCertificationLevel(0);
         appearance.setRenderingMode(RenderingMode.GRAPHIC);
         appearance.setVisibleSignature(new Rectangle(width - 20.0F, height / 2.0F, width, height / 2.0F + 60.0F), i, System.currentTimeMillis() + "");
         appearance.setSignatureGraphic(image);
         MakeSignature.signDetached(appearance, digest, pks, chain, (Collection)null, (OcspClient)null, (TSAClient)null, 0, subfilter);
         ++i;
         Files.copy(Paths.get(path, new String[0]), new FileOutputStream(new File(PDF_SIGNED)));
      }

   }

   static {
      Security.addProvider(new BouncyCastleProvider());
   }
}
